@import 'global/colors';

:host {
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;
  gap: 0.5rem;

  cursor: pointer;
  pointer-events: auto;

  padding: 0.5rem 1rem;

  border: none;
  border-radius: 0.25rem;

  font-weight: 500;
  font-size: 1rem;

  transition: transform 0.1s ease-in-out;

  > * {
    pointer-events: none;
  }

  color: var(--btn-color);
  background-color: var(--btn-background-color);
  outline: 1px solid var(--btn-outline-color);

  &:hover:not(.btn-disabled) {
    background-color: var(--btn-hover-background-color);
  }

  &:active:not(.btn-disabled) {
    transform: scale(0.95) translate3d(0, 0, 0);
  }

  &.btn-disabled {
    cursor: not-allowed;
    pointer-events: none;
    color: var(--btn-disabled-color);
    background-color: var(--btn-disabled-background-color);
    outline-color: var(--btn-disabled-outline-color);
  }

  &.btn-rounded {
    border-radius: 1rem;
  }

  &.btn-primary {
    @include theme(--btn-color, accent);
    @include theme(--btn-background-color, primary);

    @include theme(--btn-hover-background-color, primary-hover);

    @include theme(--btn-disabled-color, text-l4);
    @include theme(--btn-disabled-background-color, accent-l5);
  }

  &.btn-secondary {
    @include theme(--btn-color, text);
    @include theme(--btn-background-color, accent);
    @include theme(--btn-outline-color, accent-l5);

    @include theme(--btn-hover-background-color, accent-l2);

    @include theme(--btn-disabled-color, text-l4);
    @include theme(--btn-disabled-background-color, accent);
    @include theme(--btn-disabled-outline-color, accent-l2);
  }

  &.btn-tertiary {
    @include theme(--btn-color, text);
    @include theme(--btn-background-color, accent);

    @include theme(--btn-hover-background-color, accent-l2);

    @include theme(--btn-disabled-color, text-l4);
    @include theme(--btn-disabled-background-color, accent);
  }

  &.btn-success {
    @include theme(--btn-color, accent);
    @include theme(--btn-background-color, success);

    @include theme(--btn-hover-background-color, success-hover);

    @include theme(--btn-disabled-color, text-l4);
    @include theme(--btn-disabled-background-color, success-disabled);
  }

  &.btn-danger {
    @include theme(--btn-color, accent);
    @include theme(--btn-background-color, danger);

    @include theme(--btn-hover-background-color, danger-hover);

    @include theme(--btn-disabled-color, text-l4);
    @include theme(--btn-disabled-background-color, danger-disabled);
  }
}
